︠57dea449-8fd5-4c51-a3e6-6c559ec809b8i︠
%html
<h2>Sage Beginner's Guide, Chapter 1</h2>
<p>This is a cut/paste from Craig Finch's&nbsp;book <a href="http://www.packtpub.com/sage-beginners-guide/book" target="_self">Sage Beginner's Guide</a>, also available on <a href="http://goo.gl/v9r3q" target="_self">Amazon</a>. &nbsp;Amazing fun to study Sage using Sage, so to speak!</p>
<p>This worksheet is Chapter 1 which is an overview of many of the Sage capabilities.</p>

︡330f5ad7-db2f-4fdd-bf60-f4c69d30b5fd︡{"html": "<h2>Sage Beginner's Guide, Chapter 1</h2>\r\n<p>This is a cut/paste from Craig Finch's&nbsp;book <a href=\"http://www.packtpub.com/sage-beginners-guide/book\" target=\"_self\">Sage Beginner's Guide</a>, also available on <a href=\"http://goo.gl/v9r3q\" target=\"_self\">Amazon</a>. &nbsp;Amazing fun to study Sage using Sage, so to speak!</p>\r\n<p>This worksheet is Chapter 1 which is an overview of many of the Sage capabilities.</p>"}︡
︠5d50bb81-7fb6-49ab-8153-134e1b4a0122︠
x=var('x')
f(x) = (x^2 -1) / (x^4 + 1)
show(f)
show(derivative(f,x))
︡76210960-dd4d-4b02-a39f-a6e972d10a83︡{"html": "<div class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}x \\ {\\mapsto}\\ \\frac{x^{2} - 1}{x^{4} + 1}</div>"}︡{"html": "<div class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}x \\ {\\mapsto}\\ -\\frac{4 \\, {\\left(x^{2} - 1\\right)} x^{3}}{{\\left(x^{4} + 1\\right)}^{2}} + \\frac{2 \\, x}{x^{4} + 1}</div>"}︡
︠32ae077f-e4e9-4ecf-828f-0a2ab383ce13︠
plot(f,(-1,1))
︡1d2ba1c6-1886-4657-b72c-62547d9c124b︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠89efdffc-ed65-4d20-8c2c-cff5b6c3c7ff︠
plot(derivative(f,x),(-1,1))
︡1a60d591-5a7c-4787-a88f-3ae976ba08a6︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠f6d1217d-78a8-4375-9bc9-8069d58270ef︠
f(x) = e^x * cos(x); show(f)
f_int(x) = integrate(f,x); show(f_int)
︡18cb9ef7-e7ea-4951-9e85-75d2189a7a59︡{"html": "<div class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}x \\ {\\mapsto}\\ e^{x} \\cos\\left(x\\right)</div>"}︡{"html": "<div class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}x \\ {\\mapsto}\\ \\frac{1}{2} \\, {\\left(\\sin\\left(x\\right) + \\cos\\left(x\\right)\\right)} e^{x}</div>"}︡
︠f2f867b7-f591-4e53-aa96-efb509f5402b︠
plot(f,(x,-2,8))
︡ee8c299a-ac26-4bb0-9e43-797c4955b8dc︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠e2c8d927-09d8-43a5-b7f6-c17029865bc8︠
f(x) = sqrt(1 - x^2)
f_int = integrate(f, (x,0,1))
f_int.show()
︡c675374d-2a54-44a6-8fce-33b6e4101a9a︡{"html": "<div class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}x \\ {\\mapsto}\\ \\frac{1}{4} \\, \\pi</div>"}︡
︠1f5d412c-a2e3-4d20-9320-6bb225ea61fa︠
f(x) = (3 * x^4 + 4 * x^3 + 16 * x^2 + 20 * x + 9) / ((x + 2) * (x^2 + 3)^2)
g(x) = f.partial_fraction(x)
f.show();g.show()
︡bb240c48-2e6d-480d-ae9d-b018f1bd2dc2︡{"html": "<div class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}x \\ {\\mapsto}\\ \\frac{3 \\, x^{4} + 4 \\, x^{3} + 16 \\, x^{2} + 20 \\, x + 9}{{\\left(x + 2\\right)} {\\left(x^{2} + 3\\right)}^{2}}</div>"}︡{"html": "<div class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}x \\ {\\mapsto}\\ \\frac{2 \\, x}{x^{2} + 3} + \\frac{1}{x + 2} + \\frac{4 \\, x}{{\\left(x^{2} + 3\\right)}^{2}}</div>"}︡
︠53c39ad0-f0e9-4d6d-8463-8cb2e62e7783︠
A = Matrix(QQ, [[0, -1, -1, 1], [1, 1, 1, 1], [2, 4, 1, -2], [3, 1, -2, 2]])
B = vector([0, 6, -1, 3])
show(A);show(B.column())
show(A.solve_right(B).column())
︡93dc9453-dd8d-4f45-bf57-cb70e917699a︡{"html": "<div class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(\\begin{array}{rrrr}\n0 & -1 & -1 & 1 \\\\\n1 & 1 & 1 & 1 \\\\\n2 & 4 & 1 & -2 \\\\\n3 & 1 & -2 & 2\n\\end{array}\\right)</div>"}︡{"html": "<div class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(\\begin{array}{r}\n0 \\\\\n6 \\\\\n-1 \\\\\n3\n\\end{array}\\right)</div>"}︡{"html": "<div class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(\\begin{array}{r}\n2 \\\\\n-1 \\\\\n3 \\\\\n2\n\\end{array}\\right)</div>"}︡
︠f3e6913a-caff-47e4-9867-4fbc76cad667︠
f(x) = x^2
g(x) = x^3 - 2 * x^2 + 2
p1 = plot(f, (x, -1, 3), color='blue', axes_labels=['x', 'y'])
p2 = plot(g, (x, -1, 3), color='red')
show(p1+p2) # or just p1+p2
︡fdd934f4-cb9b-4e00-b74e-648245b5b586︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠298cbca2-fd1d-4e16-a064-48bf216a7520︠
solutions=solve(f == g, x, solution_dict=True)
for s in solutions:
    show(s)
︡da935c2d-f68d-4528-8250-b90fd37d3c94︡{"html": "<div class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left\\{x:\\: -\\sqrt{3} + 1\\right\\}</div>"}︡{"html": "<div class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left\\{x:\\: \\sqrt{3} + 1\\right\\}</div>"}︡{"html": "<div class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left\\{x:\\: 1\\right\\}</div>"}︡
︠83dc993d-67d4-40cf-af65-6a964505e789︠
labels = []; lines = []; markers = []
for s in solutions:
    x_value = s[x].n(digits=3)
    y_value = f(x_value).n(digits=3)
    labels.append(text('y=' + str(y_value), (x_value+0.5, y_value+0.5), color='black'))
    lines.append(line([(x_value, 0), (x_value, y_value)],color='black', linestyle='--'))
    markers.append(point((x_value,y_value), color='black', size=30))

show(p1+p2+sum(labels)+sum(lines)+sum(markers))
︡d90941fa-8c37-4e45-afcb-5a46e575ec58︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠1cfaa1e3-f5d2-4dd5-9d7a-7d4c6457543b︠
var('u,v')
r = 2.0
f_x = (r + cos(u / 2) * sin(v) - sin(u / 2) * sin(2 * v)) * cos(u)
f_y = (r + cos(u / 2) * sin(v) - sin(u / 2) * sin(2 * v)) * sin(u)
f_z = sin(u / 2) * sin(v) + cos(u / 2) * sin(2 * v)
parametric_plot3d([f_x, f_y, f_z], (u, 0, 2 * pi), (v, 0, 2 * pi), color="red")
︡7ff62079-4b30-48b1-98e6-64f6cedfa68a︡︡
︠36a55339-7052-4b4c-84b6-30fbc448737a︠
import numpy
var('OD, slope, intercept')
def standard_curve(OD, slope, intercept): 
    """Apply a linear standard curve to optical density data""" 
    return OD * slope + intercept
# Enter data to define standard curve 
CFU = numpy.array([2.60E+08, 3.14E+08, 3.70E+08, 4.62E+08, 8.56E+08, 1.39E+09, 1.84E+09]) 
optical_density = numpy.array([0.083, 0.125, 0.213, 0.234, 0.604, 1.092, 1.141]) 
OD_vs_CFU = zip(optical_density, CFU)
# Fit linear standard 
std_params = find_fit(OD_vs_CFU, standard_curve,
    parameters=[slope, intercept], 
    variables=[OD], initial_guess=[1e9, 3e8], 
    solution_dict = True)
for param, value in std_params.iteritems():
    print(str(param) + ' = %e' % value)
# Plot 
data_plot = scatter_plot(OD_vs_CFU, markersize=20,
    facecolor='red', axes_labels=['OD at 600nm', 'CFU/ml'])
fit_plot = plot(standard_curve(OD, std_params[slope], std_params[intercept]), (OD, 0, 1.2))
show(data_plot+fit_plot)
︡b5b956cf-524a-4763-badd-7fe4f37e1cc2︡{"stdout": "intercept = 1.237283e+08\nslope = 1.324714e+09"}︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠45b60713-060d-4702-a1f6-93c7ff20e160︠
sample_times = numpy.array([0, 20, 40, 60, 80, 100, 120, 140, 160, 180, 200, 220, 240, 280, 360, 380, 400, 420, 440, 460, 500, 520, 540, 560, 580, 600, 620, 640, 660, 680, 700, 720, 760, 1240, 1440, 1460, 1500, 1560])
OD_readings = numpy.array([0.083, 0.087, 0.116, 0.119, 0.122, 0.123, 0.125, 0.131, 0.138, 0.142, 0.158, 0.177, 0.213, 0.234, 0.424, 0.604, 0.674, 0.726, 0.758, 0.828, 0.919, 0.996, 1.024, 1.066, 1.092, 1.107, 1.113, 1.116, 1.12, 1.129, 1.132, 1.135, 1.141, 1.109, 1.004, 0.984, 0.972, 0.952])
concentrations = standard_curve(OD_readings, std_params[slope], std_params[intercept])
exp_data = zip(sample_times, concentrations)
data_plot = scatter_plot(exp_data, markersize=20, facecolor='red', axes_labels=['time (sec)', 'CFU/ml'])
show(data_plot)
︡47786447-1660-47bb-99ea-ea15dfdb8404︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠acc92b4e-8c2f-45e2-8b0a-7e8649601836︠
var('t, max_rate, lag_time, y_max, y0')
def gompertz(t, max_rate, lag_time, y_max, y0): 
    """Define a growth model based upon the Gompertz growth curve""" 
    return y0 + (y_max - y0) * numpy.exp(-numpy.exp(1.0 + 
    max_rate * numpy.exp(1) * (lag_time - t) / (y_max - y0)))
# Estimated parameter values for initial guess 
max_rate_est = (1.4e9 - 5e8)/200.0 
lag_time_est = 100 
y_max_est = 1.7e9
y0_est = 2e8
gompertz_params = find_fit(exp_data, gompertz, 
    parameters=[max_rate, lag_time, y_max, y0], 
    variables=[t], 
    initial_guess=[max_rate_est, lag_time_est, y_max_est, y0_est], 
    solution_dict = True)
for param,value in gompertz_params.iteritems(): 
    print(str(param) + ' = %e' % value)
︡21c3910f-f1ef-4a39-b0b9-5a4a87dd4ad7︡{"stdout": "y0 = 3.051120e+08\ny_max = 1.563822e+09\nlag_time = 2.950639e+02\nmax_rate = 6.606311e+06"}︡
︠402d2d58-744a-4475-abae-6dc51e26e62f︠
gompertz_model_plot = plot(gompertz(t, gompertz_params[max_rate], 
    gompertz_params[lag_time], gompertz_params[y_max], 
    gompertz_params[y0]), (t, 0, sample_times.max()))
show(gompertz_model_plot + data_plot)
︡b2a25377-6282-4674-bbd2-e966003438e2︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
